// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0

package model

import (
	"time"

	"github.com/jackc/pgx/v5/pgtype"
	"github.com/shopspring/decimal"
)

type Competition struct {
	Slug              string
	DisplayName       string
	CountrySlug       string
	CompetitionFormat string
	CompetitionType   string
	PictureUrl        string
	LogoUrl           string
	ZoneID            *int32
}

type Country struct {
	Slug            string
	Code            string
	DisplayName     string
	ThreeLetterCode string
	FlagFlat64Url   string
	FlagFlat32Url   string
	FlagRound64Url  string
	FlagRound32Url  string
}

type Fixture struct {
	Slug        string
	DisplayName string
	State       string
	StartDate   time.Time
	EndDate     time.Time
	GameWeek    int32
}

type Game struct {
	ID                 string
	Date               pgtype.Timestamptz
	CoverageStatus     string
	LowCoverage        bool
	Minutes            int32
	PeriodType         string
	Scored             bool
	Status             string
	CompetitionSlug    string
	FixtureSlug        string
	AwayTeamSlug       string
	AwayGoals          int32
	AwayExtraTimeScore int32
	AwayPenaltyScore   int32
	HomeTeamSlug       string
	HomeGoals          int32
	HomeExtraTimeScore int32
	HomePenaltyScore   int32
	WinnerTeamSlug     *string
}

type GamePlayer struct {
	GameID     string
	PlayerSlug string
	Status     string
	TeamSlug   string
}

type GamePlayerScore struct {
	GameID                 string
	PlayerSlug             string
	Score                  decimal.Decimal
	DecisiveScore          decimal.Decimal
	AllAroundScore         decimal.Decimal
	MinutesPlayed          int32
	GameStarted            bool
	FormationPlace         int32
	Live                   bool
	OnGameSheet            bool
	Reviewed               bool
	Goal                   int32
	Assist                 int32
	PenaltyWon             int32
	ClearanceOffLine       int32
	LastManTackle          int32
	PenaltySave            int32
	OwnGoal                int32
	RedCard                bool
	ErrorLeadToGoal        int32
	PenaltyConceded        int32
	YellowCard             int32
	Fouls                  int32
	Fouled                 int32
	CleanSheet             bool
	DoubleDouble           bool
	TripleDouble           bool
	TripleTriple           bool
	ErrorLeadToShot        int32
	Saves                  int32
	SavedShotFromInsideBox int32
	GoodHighClaim          int32
	Punches                int32
	DivingSave             int32
	DivingCatch            int32
	CrossNotClaimed        int32
	GoalkeeperSmother      int32
	SixSecondViolation     int32
	KeeperSweeper          int32
	GoalsConceded          int32
	EffectiveClearance     int32
	WonTackle              int32
	BlockedCross           int32
	Block                  int32
	PossessionLost         int32
	PossessionWon          int32
	DuelLost               int32
	DuelWon                int32
	Interception           int32
	AccuratePass           int32
	AccurateFinalThirdPass int32
	AccurateLongBall       int32
	LongPassIntoOpposition int32
	MissedPass             int32
	ShotOnTarget           int32
	WonContest             int32
	BigChanceCreated       int32
	AttemptedAssist        int32
	PenaltyAreaEntries     int32
	PenaltyKickMissed      int32
	BigChanceMissed        int32
}

type Player struct {
	Slug               string
	DisplayName        string
	BirthDate          time.Time
	CountrySlug        string
	TeamSlug           string
	DomesticLeagueSlug string
	AvatarUrl          string
	FieldPosition      string
	Status             string
	ShirtNumber        int32
}

type Team struct {
	Slug               string
	DisplayName        string
	CountrySlug        string
	DomesticLeagueSlug *string
	ShortName          string
	PictureUrl         string
	TeamType           string
}

type Zone struct {
	ID          int32
	DisplayName string
}
